external dsSimulationLoop
  : ?start:(unit -> unit) ->
    ?step:(int -> unit) ->
    ?command:(int -> unit) ->
    ?stop:(unit -> unit) ->
    ?path:string ->
    string array -> int -> int -> unit
  = "stub_dsSimulationLoop_byte" "stub_dsSimulationLoop_native";;

type dsXYZ = { x : float; y : float; z : float };;
type dsSides = { sx : float; sy : float; sz : float };;
type dsHPR = { hpr_h : float; hpr_p : float; hpr_r : float };;
type dsRGB = { rgb_r : float; rgb_g : float; rgb_b : float };;
type dsRGBA = { rgba_r : float; rgba_g : float; rgba_b : float; rgba_a : float };;

external dsSetViewpointRaw : float array -> float array -> unit
  = "stub_dsSetViewpoint";;

external dsSetViewpoint : dsXYZ -> dsHPR -> unit
  = "stub_dsSetViewpoint";;

external dsGetViewpointRaw : float array -> float array -> unit
  = "stub_dsGetViewpoint";;

external dsGetViewpoint : dsXYZ -> dsHPR -> unit
  = "stub_dsGetViewpoint";;

external dsStop : unit -> unit = "stub_dsStop";;

external dsElapsedTime : unit -> float = "stub_dsElapsedTime";;

external dsSetTexture : int -> unit = "stub_dsSetTexture";;

external dsSetColorRaw : float -> float -> float -> unit = "stub_dsSetColor";;

let dsSetColor rgb = dsSetColorRaw rgb.rgb_r rgb.rgb_g rgb.rgb_b;;

external dsSetColorAlphaRaw : float -> float -> float -> float -> unit
  = "stub_dsSetColorAlpha";;

let dsSetColorAlpha rgba = dsSetColorAlphaRaw rgba.rgba_r rgba.rgba_g rgba.rgba_b rgba.rgba_a;;

external dsDrawBoxRaw : float array -> float array -> float array -> unit
  = "stub_dsDrawBox";;

external dsDrawBox : Ode.LowLevel.dVector3 -> Ode.LowLevel.dMatrix3 -> dsSides -> unit
  = "stub_dsDrawBox";;

external dsDrawSphereRaw : float array -> float array -> float -> unit
  = "stub_dsDrawSphere";;

external dsDrawSphere : Ode.LowLevel.dVector3 -> Ode.LowLevel.dMatrix3 -> float -> unit
  = "stub_dsDrawSphere";;

external dsDrawTriangleRaw :
  float array -> float array -> float array -> float array -> float array -> int -> unit
  = "stub_dsDrawTriangle_byte" "stub_dsDrawTriangle_native";;

external dsDrawTriangleRaw :
  Ode.LowLevel.dVector3 -> Ode.LowLevel.dMatrix3 -> dsXYZ -> dsXYZ -> dsXYZ -> int -> unit
  = "stub_dsDrawTriangle_byte" "stub_dsDrawTriangle_native";;

external dsDrawCylinderRaw : float array -> float array -> float -> float -> unit
  = "stub_dsDrawCylinder";;

external dsDrawCylinder : Ode.LowLevel.dVector3 -> Ode.LowLevel.dMatrix3 -> float -> float -> unit
  = "stub_dsDrawCylinder";;

external dsDrawCapsuleRaw : float array -> float array -> float -> float -> unit
  = "stub_dsDrawCapsule";;

external dsDrawCapsule : Ode.LowLevel.dVector3 -> Ode.LowLevel.dMatrix3 -> float -> float -> unit
  = "stub_dsDrawCapsule";;

external dsDrawLineRaw : float array -> float array -> unit
  = "stub_dsDrawLine";;

external dsDrawLine : Ode.LowLevel.dVector3 -> Ode.LowLevel.dVector3 -> unit
  = "stub_dsDrawLine";;

external dsDrawConvex :
  Ode.LowLevel.dVector3 -> Ode.LowLevel.dVector3 -> Ode.LowLevel.dVector3 list
  -> dsXYZ list -> int list -> unit
  = "stub_dsDrawConvex";;

external dsSetSphereQuality : int -> unit
  = "stub_dsSetSphereQuality";;

external dsSetCapsuleQuality : int -> unit
  = "stub_dsSetCapsuleQuality";;
